//#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include "utils.h"
#include "lpc2148.h"
#include "uart.h"
#include "TLC5940.h"

extern void stdioInit(void);          // in os/arch/syscalls.c
extern void enable_interrupts(void);  // in startup_gcc.S
extern void disable_interrupts(void); // in startup_gcc.S

/*****************************************************************************
	Function Name : Hardwareinit()
	Description   : Initialize Blueboard Hardware
******************************************************************************/
void  HardwareInit(void)
{
    lpc_pll_init();
    SCS = 3;    //sets port 1 and 0 to fast mode (not compatable with previous LPCs)
    uart0Init(B19200, UART_8N2);

    // Die folgende Funktion soll spter die stdio Bibliothek initialisieren
    // Sie ist im Moment leer und bringt trotzdem den Prozessor zum Absturz wenn entkommentiert
    //stdioInit();
    // set stdio to unbuffered
    setvbuf(stdin , NULL, _IONBF, 0);
    setvbuf(stdout, NULL, _IONBF, 0);
    setvbuf(stderr, NULL, _IONBF, 0);

    enable_interrupts();
}

/*
 * use timer 0 for delays
 */
void mydelay(uint16_t ti)
{
    /* My PCLK of Timer0 is 18Mhz */
    T0PR  = 9999;          // Prescale Register = 9999
    T0MR0 = ti;            // Match Register    =  900
    T0MCR = 0x00000004;    // Stop on MR0: the TC and PC will be stopped
                           // and TCR[0] will be set to 0 if MR0 matches the TC.
    T0TCR = 0x02;          // Counter Reset
    T0TCR = 0x01;          // Counter Enable
    while(T0TC != T0MR0);
}

/*****************************************************************************
	Function Name :	main()
	Description   : Show a software and a hardware timed counter on LCD
******************************************************************************/
int main(void)
{
	char s[10];

    HardwareInit();
    uart0Puts("\r\nLED Cube Controller\r\n");
    itoa(PCLK/1000000,s , 10);
    uart0Puts("PCLK:     "); uart0Puts(s); uart0Puts(" MHz\r\n");
    mydelay(100);
//    TLC5940_init();  // Dies ist die Timer Initialisierung die das Ganze zum Absturz bringt
    while (1)
    {
        uart0Putch('*');
        mydelay(100);
    }
}

