#include "lpc_config.h"
#include "lpc_2148.h"
#include "lpc_scb.h"

/*******************************************************************
	Function Name : lpc_pll_init()
	Description   : Setup IO Clock PLL
********************************************************************/
void lpc_pll_init(void)
{
  // set PLL multiplier & divisor.
  // values computed from config
  PLLCFG = PLLCFG_MSEL | PLLCFG_PSEL;
  // enable PLL
  PLLCON = PLLCON_PLLE;
  PLLFEED = 0xAA;                       // Make it happen.  These two updates
  PLLFEED = 0x55;                       // MUST occur in sequence.

  // wait for PLL lock
  while (!(PLLSTAT & PLLSTAT_LOCK))
    continue;

  // enable & connect PLL
  PLLCON = PLLCON_PLLE | PLLCON_PLLC;
  PLLFEED = 0xAA;                       // Make it happen.  These two updates
  PLLFEED = 0x55;                       // MUST occur in sequence.

  // setup & enable the MAM
  MAMTIM = MAMTIM_CYCLES;
  MAMCR = MAMCR_FULL;
  // set the peripheral bus speed
  // value computed from config.h
  VPBDIV = VPBDIV_VALUE;                // set the peripheral bus clock speed
}
