/**
 * TLC5940 Driver library for LPC2148
 * (C) Thorsten Erdmann (thorsten@trektech.de)
 **/

#ifndef TLC5940_h
#define TLC5940_h

#define TLCPORT FIO0
#define BLANK BIT(13)       // will be served by pwm0 ISR
#define VPRG  BIT(22)
#define XLAT  BIT(11)       // later BIT(20) in original PCB
#define GSCLK BIT(12)       // will be served from timer1
#define DCPRG BIT(21)
#define ROWA  BIT(8)
#define ROWB  BIT(9)
#define ROWC  BIT(10)
#define ROWD  BIT(11)
#define MOSI0 BIT(6)
#define MISO0 BIT(5)
#define SCK0  BIT(4)

/**
 * Initialize TLC5940 driver
 **/
void TLC5940_init(void);

#endif // TLC5940_h
